diff -Naur src.pgsql/backend/access/Makefile src.bizgres/backend/access/Makefile
--- src.pgsql/backend/access/Makefile	2006-07-17 17:05:14.000000000 -0700
+++ src.bizgres/backend/access/Makefile	2006-07-17 22:33:22.000000000 -0700
@@ -1,14 +1,14 @@
 #
 # Makefile for the access methods module
 #
-# $PostgreSQL: pgsql/src/backend/access/Makefile,v 1.11 2006/05/02 11:28:54 teodor Exp $
+# $PostgreSQL: pgsql/src/backend/access/Makefile,v 1.9 2003/11/29 19:51:39 pgsql Exp $
 #
 
 subdir = src/backend/access
 top_builddir = ../../..
 include $(top_builddir)/src/Makefile.global
 
-SUBDIRS	    := common gist hash heap index nbtree transam gin
+SUBDIRS	    := common gist hash heap index nbtree transam gin bitmap
 SUBDIROBJS  := $(SUBDIRS:%=%/SUBSYS.o)
 
 all: SUBSYS.o
diff -Naur src.pgsql/backend/access/bitmap/Makefile src.bizgres/backend/access/bitmap/Makefile
--- src.pgsql/backend/access/bitmap/Makefile	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/access/bitmap/Makefile	2006-07-17 22:33:21.000000000 -0700
@@ -0,0 +1,34 @@
+#-------------------------------------------------------------------------
+#
+# Makefile--
+#    Makefile for access/bitmap
+#
+# Copyright (c) 2006, Greenplum, Inc.
+#
+# IDENTIFICATION
+#    $PostgreSQL$
+#
+#-------------------------------------------------------------------------
+
+subdir = src/backend/access/bitmap
+top_builddir = ../../../..
+include $(top_builddir)/src/Makefile.global
+
+OBJS = bitmapcompare.o bitmaputil.o bitmapattutil.o \
+bitmappages.o bitmapinsert.o bitmapsearch.o bitmap.o bitmapxlog.o
+
+all: SUBSYS.o
+
+SUBSYS.o: $(OBJS)
+	$(LD) $(LDREL) $(LDOUT) SUBSYS.o $(OBJS)
+
+depend dep:
+	$(CC) -MM $(CFLAGS) *.c >depend
+
+clean: 
+	rm -f SUBSYS.o $(OBJS)
+
+ifeq (depend,$(wildcard depend))
+include depend
+endif
+
diff -Naur src.pgsql/backend/access/bitmap/bitmap.c src.bizgres/backend/access/bitmap/bitmap.c
--- src.pgsql/backend/access/bitmap/bitmap.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/access/bitmap/bitmap.c	2006-07-17 22:33:21.000000000 -0700
@@ -0,0 +1,586 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmap.c
+ *	Implementation of the Hybrid Run-Length (HRL) on-disk bitmap index.
+ *
+ * Copyright (c) 2006, Greenplum, Inc.
+ *
+ * IDENTIFICATION
+ *	$PostgreSQL$
+ *
+ * NOTES
+ *	This file contains only the public interface routines.
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "access/genam.h"
+#include "access/bitmap.h"
+#include "access/xact.h"
+#include "catalog/index.h"
+#include "storage/lmgr.h"
+#include "parser/parse_oper.h"
+
+static void bmbuildCallback(Relation index,
+							HeapTuple htup,
+							Datum *attdata,
+							bool *nulls,
+							bool tupleIsAlive,
+							void *state);
+
+
+/*
+ * bmbuild() -- Build a new bitmap index.
+ */
+Datum
+bmbuild(PG_FUNCTION_ARGS)
+{
+	Relation    heap = (Relation) PG_GETARG_POINTER(0);
+	Relation    index = (Relation) PG_GETARG_POINTER(1);
+	IndexInfo  *indexInfo = (IndexInfo *) PG_GETARG_POINTER(2);
+	double      reltuples;
+	BMBuildState bmstate;
+	IndexBuildResult *result;
+	TupleDesc	tupDesc;
+
+	/* We expect this to be called exactly once. */
+	if (RelationGetNumberOfBlocks(index) != 0)
+		ereport (ERROR,
+				(errcode(ERRCODE_INDEX_CORRUPTED),
+				errmsg("index \"%s\" already contains data",
+				RelationGetRelationName(index))));
+
+	tupDesc = RelationGetDescr(index);
+	if (tupDesc->natts <= 0)
+		PG_RETURN_VOID () ;
+
+	/* disable multi-column index support for now. */
+	if (tupDesc->natts > 1)
+		ereport(ERROR, (errcode(ERROR),
+			errmsg("No multi-column index support for on-disk bitmap "
+				   "index yet."))
+			);
+
+	/* initialize the bitmap index. */
+	_bitmap_init(index);
+
+	/* initialize the build state. */
+	_bitmap_init_buildstate(index, &bmstate);
+
+	/* do the heap scan */
+	reltuples = IndexBuildHeapScan(heap, index, indexInfo,
+								   bmbuildCallback, (void*)&bmstate);
+
+	/* clean up the build state */
+	_bitmap_cleanup_buildstate(index, &bmstate);
+
+	/*
+	 * Return statistics
+	 */
+	result = (IndexBuildResult *) palloc(sizeof(IndexBuildResult));
+
+	result->heap_tuples = reltuples;
+	result->index_tuples = bmstate.ituples;
+
+	PG_RETURN_POINTER(result);
+}
+
+/*
+ * Per-tuple callback from IndexBuildHeapScan
+ */
+static void
+bmbuildCallback(Relation index,
+				HeapTuple htup,
+				Datum *attdata,
+				bool *nulls,
+				bool tupleIsAlive,
+				void *state)
+{
+	BMBuildState *bstate = (BMBuildState *) state;
+
+	_bitmap_buildinsert(index, htup->t_self, attdata, nulls, bstate);
+
+	bstate->ituples += 1;
+}
+
+/*
+ * bminsert() -- insert an index tuple into a bitmap index.
+ */
+Datum
+bminsert(PG_FUNCTION_ARGS)
+{
+	Relation	rel = (Relation) PG_GETARG_POINTER(0);
+	Datum		*datum = (Datum *) PG_GETARG_POINTER(1);
+	bool		*nulls = (bool *) PG_GETARG_POINTER(2);
+	ItemPointer	ht_ctid = (ItemPointer) PG_GETARG_POINTER(3);
+
+#ifdef NOT_USED
+	Relation	heapRel = (Relation) PG_GETARG_POINTER(4);
+	bool		checkUnique = PG_GETARG_BOOL(5);
+#endif
+
+	_bitmap_doinsert(rel, *ht_ctid, datum, nulls);
+
+	PG_RETURN_BOOL(true);
+}
+
+/*
+ * bmgettuple() -- return the next tuple in a scan.
+ */
+Datum
+bmgettuple(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	ScanDirection dir = (ScanDirection) PG_GETARG_INT32(1);
+
+	bool res;
+
+	/* If we have already started this scan, then we just continue this
+	   scan in the appropriate direction. */
+	if (ItemPointerIsValid(&(scan->currentItemData)))
+		res = _bitmap_next(scan, dir);
+	else
+		res = _bitmap_first(scan, dir);
+
+	PG_RETURN_BOOL(res);
+}
+
+/*
+ * bmgetmulti() -- return multiple tuples at once in a scan.
+ */
+Datum
+bmgetmulti(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	ItemPointer	tids = (ItemPointer) PG_GETARG_POINTER(1);
+	int32		max_tids = PG_GETARG_INT32(2);
+	int32		*returned_tids = (int32 *) PG_GETARG_POINTER(3);
+
+	bool		res = false;
+	int32		ntids = 0;
+
+	while (ntids < max_tids)
+	{
+		if (ItemPointerIsValid(&(scan->currentItemData)))
+			res = _bitmap_next(scan, ForwardScanDirection);
+		else
+			res = _bitmap_first(scan, ForwardScanDirection);
+
+		if (!res)
+			break ;
+
+		tids[ntids] = scan->xs_ctup.t_self;
+		ntids ++;
+	}
+
+	*returned_tids = ntids;
+	PG_RETURN_BOOL(res);
+}
+
+/*
+ * bmbeginscan() -- start a scan on the bitmap index.
+ */
+Datum
+bmbeginscan(PG_FUNCTION_ARGS)
+{
+	Relation	rel = (Relation) PG_GETARG_POINTER(0);
+	int			nkeys = PG_GETARG_INT32(1);
+	ScanKey		scankey = (ScanKey) PG_GETARG_POINTER(2);
+	IndexScanDesc scan;
+
+	/* get the scan */
+	scan = RelationGetIndexScan(rel, nkeys, scankey);
+
+	PG_RETURN_POINTER(scan);
+}
+
+/*
+ * bmrescan() -- restart a scan on the bitmap index.
+ */
+Datum
+bmrescan(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc	scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	ScanKey			scankey = (ScanKey) PG_GETARG_POINTER(1);
+	ItemPointer	iptr;
+	BMScanOpaque	so = (BMScanOpaque) scan->opaque;
+	BMBitmapScanPosition	bmScanPos;
+	uint32			keyNo;
+
+	if (so == NULL) 		/* if called from bmbeginscan */
+	{
+		so = (BMScanOpaque) palloc(sizeof(BMScanOpaqueData));
+		so->bm_currPos = NULL;
+		so->bm_markPos = NULL;
+
+		scan->opaque = so;
+	}
+
+	if (ItemPointerIsValid(iptr = &(scan->currentItemData)))
+	{
+		Assert(so->bm_currPos != NULL);
+
+		/* release the buffers that have been stored for each related 
+		   bitmap vector. */
+		bmScanPos = (BMBitmapScanPosition) 
+			(((char*)so->bm_currPos) + MAXALIGN(sizeof(BMScanPositionData)));
+
+		for (keyNo=0; keyNo<so->bm_currPos->bm_numBitmapVectors; keyNo++)
+		{
+			if (BufferIsValid((bmScanPos[keyNo]).bm_lovBuffer))
+				ReleaseBuffer((bmScanPos[keyNo]).bm_lovBuffer);
+			_bitmap_cleanup_batchwords((bmScanPos[keyNo]).bm_batchWords);
+			if (bmScanPos[keyNo].bm_batchWords != NULL)
+				pfree((bmScanPos[keyNo]).bm_batchWords);
+		}
+
+		pfree(so->bm_currPos);
+		so->bm_currPos = NULL;
+		
+		ItemPointerSetInvalid(iptr);
+	}
+
+	if (ItemPointerIsValid(iptr = &(scan->currentMarkData)))
+	{
+		Assert(so->bm_markPos != NULL);
+
+		bmScanPos = (BMBitmapScanPosition) 
+			(((char*)so->bm_markPos) + MAXALIGN(sizeof(BMScanPositionData)));
+
+		for (keyNo=0; keyNo<so->bm_currPos->bm_numBitmapVectors; keyNo++)
+		{
+			if (BufferIsValid((bmScanPos[keyNo]).bm_lovBuffer))
+				ReleaseBuffer((bmScanPos[keyNo]).bm_lovBuffer);
+			_bitmap_cleanup_batchwords((bmScanPos[keyNo]).bm_batchWords);
+			if (bmScanPos[keyNo].bm_batchWords != NULL)
+				pfree((bmScanPos[keyNo]).bm_batchWords);
+		}
+
+		pfree(so->bm_markPos);
+		so->bm_markPos = NULL;
+
+		ItemPointerSetInvalid(iptr);
+	}
+
+	/* reset the scan key */
+	if (scankey && scan->numberOfKeys > 0)
+		memmove(scan->keyData, scankey,
+				scan->numberOfKeys * sizeof(ScanKeyData));
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * bmendscan() -- close a scan.
+ */
+Datum
+bmendscan(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc	scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	BMScanOpaque	so = (BMScanOpaque) scan->opaque;
+
+	BMBitmapScanPosition	bmScanPos;
+	uint32 keyNo;
+
+	/* free the space */
+	if (so->bm_currPos != NULL)
+	{
+
+		/* release the buffers that have been stored for each related bitmap.*/
+		bmScanPos = (BMBitmapScanPosition) 
+			(((char*)so->bm_currPos) + MAXALIGN(sizeof(BMScanPositionData)));
+
+		for (keyNo=0; keyNo<so->bm_currPos->bm_numBitmapVectors; keyNo++)
+		{
+			if (BufferIsValid((bmScanPos[keyNo]).bm_lovBuffer))
+				ReleaseBuffer((bmScanPos[keyNo]).bm_lovBuffer);
+			_bitmap_cleanup_batchwords((bmScanPos[keyNo]).bm_batchWords);
+			if (bmScanPos[keyNo].bm_batchWords != NULL)
+				pfree((bmScanPos[keyNo]).bm_batchWords);
+		}
+
+		pfree(so->bm_currPos);
+		so->bm_currPos = NULL;
+	}
+
+	if (so->bm_markPos != NULL)
+	{
+		bmScanPos = (BMBitmapScanPosition) 
+			(((char*)so->bm_markPos) + MAXALIGN(sizeof(BMScanPositionData)));
+
+		for (keyNo=0; keyNo<so->bm_currPos->bm_numBitmapVectors; keyNo++)
+		{
+			if (BufferIsValid((bmScanPos[keyNo]).bm_lovBuffer))
+				ReleaseBuffer((bmScanPos[keyNo]).bm_lovBuffer);
+			_bitmap_cleanup_batchwords((bmScanPos[keyNo]).bm_batchWords);
+			if (bmScanPos[keyNo].bm_batchWords != NULL)
+				pfree((bmScanPos[keyNo]).bm_batchWords);
+		}
+
+		pfree(so->bm_markPos);
+		so->bm_markPos = NULL;
+	}
+
+	pfree(so);
+
+	scan->opaque = NULL;
+
+	if (ItemPointerIsValid(&(scan->currentItemData)))
+		ItemPointerSetInvalid(&(scan->currentItemData));
+	if (ItemPointerIsValid(&(scan->currentMarkData)))
+		ItemPointerSetInvalid(&(scan->currentMarkData));
+
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * bmmarkpos() -- save the current scan position.
+ */
+Datum
+bmmarkpos(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc	scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	BMScanOpaque	so = (BMScanOpaque) scan->opaque;
+
+	BMBitmapScanPosition	bmScanPos;
+	uint32 keyNo;
+
+	/* free the space */
+	if (ItemPointerIsValid(&(scan->currentMarkData)))
+	{
+		/* release the buffers that have been stored for each related bitmap.*/
+		bmScanPos = (BMBitmapScanPosition) 
+			(((char*)so->bm_markPos) + MAXALIGN(sizeof(BMScanPositionData)));
+
+		for (keyNo=0; keyNo<scan->numberOfKeys; keyNo++)
+		{
+			if (BufferIsValid((bmScanPos[keyNo]).bm_lovBuffer))
+			{
+				ReleaseBuffer((bmScanPos[keyNo]).bm_lovBuffer);
+				(bmScanPos[keyNo]).bm_lovBuffer = InvalidBuffer;
+			}
+		}
+		
+		ItemPointerSetInvalid(&(scan->currentMarkData));
+	}
+
+	if (ItemPointerIsValid(&(scan->currentItemData)))
+	{
+		uint32	size = MAXALIGN(sizeof(BMScanPositionData)) +
+					   scan->numberOfKeys * sizeof(BMBitmapScanPositionData);
+		/* set the mark position */
+		if (so->bm_markPos == NULL)
+		{
+			so->bm_markPos = (BMScanPosition) 
+				palloc(size);
+		}
+
+		bmScanPos = (BMBitmapScanPosition) 
+			(((char*)so->bm_currPos) + MAXALIGN(sizeof(BMScanPositionData)));
+
+		for (keyNo=0; keyNo<scan->numberOfKeys; keyNo++)
+		{
+			if (BufferIsValid((bmScanPos[keyNo]).bm_lovBuffer))
+				IncrBufferRefCount((bmScanPos[keyNo]).bm_lovBuffer);
+		}		
+
+		memcpy(so->bm_markPos, so->bm_currPos, size);
+
+		scan->currentMarkData = scan->currentItemData;
+	}
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * bmrestrpos() -- restore a scan to the last saved position.
+ */
+Datum
+bmrestrpos(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc	scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	BMScanOpaque	so = (BMScanOpaque) scan->opaque;
+
+	BMBitmapScanPosition	bmScanPos;
+	uint32 keyNo;
+
+	/* free space */
+	if (ItemPointerIsValid(&(scan->currentItemData)))
+	{
+		/* release the buffers that have been stored for each related bitmap.*/
+		bmScanPos = (BMBitmapScanPosition) 
+			(((char*)so->bm_currPos) + MAXALIGN(sizeof(BMScanPositionData)));
+
+		for (keyNo=0; keyNo<scan->numberOfKeys; keyNo++)
+		{
+			if (BufferIsValid((bmScanPos[keyNo]).bm_lovBuffer))
+			{
+				ReleaseBuffer((bmScanPos[keyNo]).bm_lovBuffer);
+				(bmScanPos[keyNo]).bm_lovBuffer = InvalidBuffer;
+			}
+		}
+
+		ItemPointerSetInvalid(&(scan->currentItemData));
+	}
+
+	if (ItemPointerIsValid(&(scan->currentMarkData)))
+	{
+		uint32	size = MAXALIGN(sizeof(BMScanPositionData)) +
+					   scan->numberOfKeys * sizeof(BMBitmapScanPositionData);
+
+		/* set the current position */
+		if (so->bm_currPos == NULL)
+		{
+			so->bm_currPos = (BMScanPosition) palloc(size);
+		}
+
+		bmScanPos = (BMBitmapScanPosition) 
+			(((char*)so->bm_markPos) + MAXALIGN(sizeof(BMScanPositionData)));
+
+		for (keyNo=0; keyNo<scan->numberOfKeys; keyNo++)
+		{
+			if (BufferIsValid((bmScanPos[keyNo]).bm_lovBuffer))
+				IncrBufferRefCount((bmScanPos[keyNo]).bm_lovBuffer);
+		}		
+
+		memcpy(so->bm_currPos, so->bm_markPos, size);
+		scan->currentItemData = scan->currentMarkData;
+	}
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * bmbulkdelete() -- bulk delete index entries
+ *
+ * Re-index is performed before retrieving the number of tuples
+ * indexed in this index.
+ */
+Datum
+bmbulkdelete(PG_FUNCTION_ARGS)
+{
+	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
+	Relation	rel = info->index;
+	IndexBulkDeleteResult* result;
+	double		numTuples;
+	bool		needRebuilt = false;
+	Buffer		metabuf;
+	BMMetaPage	metapage;
+
+	if (!info->vacuum_full)
+	{
+		/* obtain the indicator if this index needs to be re-built. */
+		metabuf = _bitmap_getbuf(rel, BM_METAPAGE, BM_READ);
+		metapage = (BMMetaPage)BufferGetPage(metabuf);
+		needRebuilt = metapage->bm_need_rebuilt;
+		_bitmap_relbuf(metabuf);
+	}
+
+	if (needRebuilt || info->vacuum_full) {
+		reindex_index(RelationGetRelid(rel));
+		CommandCounterIncrement();
+	}
+
+	/* obtain the number of tuples from the index */
+	metabuf = _bitmap_getbuf(rel, BM_METAPAGE, BM_READ);
+	metapage = (BMMetaPage)BufferGetPage(metabuf);
+	numTuples = metapage->bm_num_tuples;
+	_bitmap_relbuf(metabuf);
+	
+	result = (IndexBulkDeleteResult *) palloc0(sizeof(IndexBulkDeleteResult));
+	result->num_pages = RelationGetNumberOfBlocks(rel);
+	result->num_index_tuples = numTuples;
+	result->tuples_removed = 0;
+	
+	PG_RETURN_POINTER(result);
+
+}
+
+/*
+ * bmvacuumcleanup() -- post-vacuum cleanup.
+ *
+ * We do nothing useful here.
+ */
+Datum
+bmvacuumcleanup(PG_FUNCTION_ARGS)
+{
+	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
+	Relation	rel = info->index;
+	IndexBulkDeleteResult *stats = 
+		(IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
+
+	/* update statistics */
+	stats->num_pages = RelationGetNumberOfBlocks(rel);
+	stats->pages_deleted = 0;
+	stats->pages_free = 0;
+
+	PG_RETURN_POINTER(stats);
+}
+
+/*
+ * bmgetbitmapwords() -- return a given number of bitmap words in a scan.
+ */
+Datum
+bmgetbitmapwords(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc	scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	uint32			maxNumOfBitmapWords = PG_GETARG_UINT32(1);
+	uint32*			returnedNumOfBitmapWords = (uint32*)PG_GETARG_POINTER(2);
+	BM_HRL_WORD*	bitmapHeaderWords = (BM_HRL_WORD*)PG_GETARG_POINTER(3);
+	BM_HRL_WORD*	bitmapContentWords = (BM_HRL_WORD*)PG_GETARG_POINTER(4);
+
+	bool 	res = false;
+
+	Assert(maxNumOfBitmapWords > 0 &&
+		   maxNumOfBitmapWords%BM_HRL_WORD_SIZE == 0 &&
+		   maxNumOfBitmapWords%BM_NUM_OF_HRL_WORDS_PER_PAGE == 0);
+
+	*returnedNumOfBitmapWords = 0;
+	while ((*returnedNumOfBitmapWords) < maxNumOfBitmapWords)
+	{
+		BMScanPosition	scanPos;
+		int32			numOfWords = 0;
+
+		if (((BMScanOpaque)(scan->opaque))->bm_currPos != NULL)
+			res = _bitmap_nextblockwords(scan, ForwardScanDirection);
+		else
+			res = _bitmap_firstblockwords(scan, ForwardScanDirection);
+
+		if (!res)
+			break;
+
+		scanPos = ((BMScanOpaque) scan->opaque)->bm_currPos;
+		if (scanPos->bm_batchWords->numOfWords >= 
+			(maxNumOfBitmapWords - *returnedNumOfBitmapWords))
+			numOfWords = maxNumOfBitmapWords - *returnedNumOfBitmapWords;
+		else
+			numOfWords = scanPos->bm_batchWords->numOfWords;
+
+		/* copy the content words */
+		memcpy(bitmapContentWords + *returnedNumOfBitmapWords,
+			   scanPos->bm_batchWords->bitmapContentWords,
+			   numOfWords*sizeof(BM_HRL_WORD));
+
+		/* copy the header words */
+		memcpy(bitmapHeaderWords +
+				(*returnedNumOfBitmapWords)/BM_HRL_WORD_SIZE,
+				scanPos->bm_batchWords->bitmapHeaderWords,
+				(numOfWords/BM_HRL_WORD_SIZE + 
+				((numOfWords%BM_HRL_WORD_SIZE == 0) ? 0 : 1))*
+				 sizeof(BM_HRL_WORD));
+
+		*returnedNumOfBitmapWords += numOfWords;
+
+		_bitmap_reset_batchwords(scanPos->bm_batchWords);
+
+		if (*returnedNumOfBitmapWords%BM_HRL_WORD_SIZE != 0)
+			break;
+	}
+
+	if (*returnedNumOfBitmapWords > 0)
+		PG_RETURN_BOOL(true);
+	else
+		PG_RETURN_BOOL(false);
+}
diff -Naur src.pgsql/backend/access/bitmap/bitmapattutil.c src.bizgres/backend/access/bitmap/bitmapattutil.c
--- src.pgsql/backend/access/bitmap/bitmapattutil.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/access/bitmap/bitmapattutil.c	2006-07-17 22:33:21.000000000 -0700
@@ -0,0 +1,390 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmapattutil.c
+ *	Defines the routines to maintain all distinct attribute values
+ *	which are indexed in the on-disk bitmap index.
+ *
+ * Copyright (c) 2006, Greenplum, Inc.
+ *
+ *
+ * IDENTIFICATION
+ *	  $PostgreSQL$
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "access/genam.h"
+#include "access/tupdesc.h"
+#include "access/bitmap.h"
+#include "access/nbtree.h"
+#include "access/xact.h"
+#include "nodes/execnodes.h"
+#include "nodes/primnodes.h"
+#include "nodes/makefuncs.h"
+#include "catalog/dependency.h"
+#include "catalog/heap.h"
+#include "catalog/index.h"
+#include "catalog/pg_type.h"
+#include "catalog/namespace.h"
+#include "access/heapam.h"
+#include "optimizer/clauses.h"
+#include "utils/syscache.h"
+#include "utils/lsyscache.h"
+#include "utils/builtins.h"
+#include "commands/defrem.h"
+#include "commands/tablecmds.h"
+
+static TupleDesc _bitmap_create_lov_heapTupleDesc(Relation rel);
+
+/*
+ * _bitmap_create_lov_heapandindex() -- create a new heap relation and
+ *	a btree index for LOV.
+ */
+void
+_bitmap_create_lov_heapandindex(Relation rel,
+								Oid *lovHeapId, Oid *lovIndexId)
+{
+	char		lovHeapName[NAMEDATALEN];
+	char		lovIndexName[NAMEDATALEN];
+	TupleDesc	tupDesc;
+	IndexInfo  *indexInfo;
+	ObjectAddress	objAddr, referenced;
+	Oid			accessMethodId = BTREE_AM_OID;
+	Oid*		classObjectId;
+	int			numOfIndexAttrs;
+	int			attno;
+
+	/* create the new names for the new lov heap and index */
+	snprintf(lovHeapName, sizeof(lovHeapName), 
+			 "bm_internal_t%u%s", RelationGetNamespace(rel), 
+			 RelationGetRelationName(rel));
+	snprintf(lovIndexName, sizeof(lovIndexName), 
+			 "bm_internal_i%u%s", RelationGetNamespace(rel), 
+			 RelationGetRelationName(rel));
+
+	/*
+	 * If this is happening during re-indexing, then such a heap should
+	 * have existed already. Here, we delete this heap and its btree
+	 * index first.
+	 */
+	if ((*lovHeapId =
+		 get_relname_relid(lovHeapName, RelationGetNamespace(rel))) &&
+		(*lovIndexId =
+		 get_relname_relid(lovIndexName, RelationGetNamespace(rel))))
+	{
+		RangeVar *indexRel;
+
+		/* remove the dependency among the lov heap relation, 
+		   the lov index, and the parent bitmap index before 
+		   drop the lov heap and index. */
+		deleteDependencyRecordsFor(RelationRelationId, *lovIndexId);
+		deleteDependencyRecordsFor(RelationRelationId, *lovHeapId);
+
+		CommandCounterIncrement();
+
+		indexRel = makeRangeVar(NULL, NULL);
+		indexRel->relname = lovIndexName;
+		RemoveRelation(indexRel, DROP_RESTRICT);
+
+		pfree(indexRel);
+		indexRel = makeRangeVar(NULL, NULL);
+		indexRel->relname = lovHeapName;
+		RemoveRelation(indexRel, DROP_RESTRICT);
+		pfree(indexRel);
+	}
+
+	/*
+	 * create a new empty heap to store all attribute values with their
+	 * corresponding block number and offset in LOV.
+	 */
+	tupDesc = _bitmap_create_lov_heapTupleDesc(rel);
+
+	*lovHeapId = 
+		heap_create_with_catalog
+			(lovHeapName, RelationGetNamespace(rel),
+			 rel->rd_rel->reltablespace, InvalidOid, 
+			 rel->rd_rel->relowner, tupDesc, RELKIND_RELATION,
+			 rel->rd_rel->relisshared, false, 1, ONCOMMIT_NOOP,
+			 false, true);
+
+	/*
+	 * We must bump the command counter to make the newly-created relation
+	 * tuple visible for opening.
+	 */
+	CommandCounterIncrement();
+
+	objAddr.classId = RelationRelationId;
+	objAddr.objectId = *lovHeapId;
+	objAddr.objectSubId = 0 ;
+
+	referenced.classId = RelationRelationId;
+	referenced.objectId = RelationGetRelid(rel);
+	referenced.objectSubId = 0;
+
+	recordDependencyOn(&objAddr, &referenced, DEPENDENCY_INTERNAL);
+
+	/*
+	 * create a btree index on the newly-created heap. 
+	 * The key includes all attributes to be indexed in this bitmap index.
+	 */
+	numOfIndexAttrs = tupDesc->natts - 2;
+	indexInfo = makeNode(IndexInfo);
+	indexInfo->ii_NumIndexAttrs = numOfIndexAttrs;
+	indexInfo->ii_Expressions = NIL;
+	indexInfo->ii_ExpressionsState = NIL;
+	indexInfo->ii_Predicate = make_ands_implicit(NULL);
+	indexInfo->ii_PredicateState = NIL;
+	indexInfo->ii_Unique = true;
+
+	classObjectId = (Oid*)palloc(numOfIndexAttrs*sizeof(Oid));
+	for (attno = 0; attno < numOfIndexAttrs; attno++) {
+		indexInfo->ii_KeyAttrNumbers[attno] = attno+1;
+		classObjectId[attno] = 
+			GetDefaultOpClass(tupDesc->attrs[attno]->atttypid, 
+							  accessMethodId);
+	}
+
+	*lovIndexId = 
+		index_create(*lovHeapId, lovIndexName, InvalidOid,
+					 indexInfo, accessMethodId, rel->rd_rel->reltablespace, 
+					 classObjectId, 0, false, false, false, true, false);
+
+
+	objAddr.classId = RelationRelationId;
+	objAddr.objectId = *lovIndexId;
+	objAddr.objectSubId = 0 ;
+
+	recordDependencyOn(&objAddr, &referenced, DEPENDENCY_INTERNAL);
+}
+
+/*
+ * _bitmap_create_lov_heapTupleDesc() -- create the new heap tuple descriptor.
+ */
+TupleDesc
+_bitmap_create_lov_heapTupleDesc(Relation rel)
+{
+	TupleDesc	tupDesc;
+	TupleDesc	oldTupDesc;
+	AttrNumber	attnum;
+
+	int			numOfAttrs;
+
+	oldTupDesc = RelationGetDescr(rel);
+	numOfAttrs = oldTupDesc->natts + 2;
+
+	tupDesc = CreateTemplateTupleDesc(numOfAttrs, false);
+
+	for (attnum = 1; attnum <= oldTupDesc->natts; attnum++) {
+		/* cope the attribute to be indexed. */
+		memcpy(tupDesc->attrs[attnum-1], oldTupDesc->attrs[attnum-1], 
+			   ATTRIBUTE_TUPLE_SIZE);
+		(tupDesc->attrs[attnum-1])->attnum = attnum;
+	}
+
+	/* the block number */
+	TupleDescInitEntry(tupDesc, attnum, "blockNumber", INT4OID, -1, 0);
+	
+	attnum++;
+
+	/* the offset number */
+	TupleDescInitEntry(tupDesc, attnum, "offsetNumber", INT4OID, -1, 0);
+
+	return tupDesc;
+}
+
+/*
+ * _bitmap_open_lov_heapandindex() -- open the heap relation and the btree
+ *		index for LOV.
+ */
+void
+_bitmap_open_lov_heapandindex(Relation rel, BMMetaPage metapage,
+							  Relation *lovHeapP, Relation *lovIndexP,
+							  LOCKMODE lockMode)
+{
+	*lovHeapP = heap_open(metapage->bm_lov_heapId, lockMode);
+	*lovIndexP = index_open(metapage->bm_lov_indexId);
+}
+
+/*
+ * _bitmap_insert_lov() -- insert a new data into the given heap and index.
+ */
+void
+_bitmap_insert_lov(Relation lovHeap, Relation lovIndex,
+				   Datum* datum, bool* nulls)
+{
+	TupleDesc	tupDesc;
+	HeapTuple	tuple;
+	bool		result;
+
+	Datum*		indexDatum;
+	bool*		indexNulls;
+
+	tupDesc = RelationGetDescr(lovHeap);
+
+	/* insert this tuple into the heap */
+	tuple = heap_form_tuple(tupDesc, datum, nulls);
+	simple_heap_insert(lovHeap, tuple);
+
+	/* insert a new tuple into the index */
+	indexDatum = palloc0((tupDesc->natts-2) * sizeof(Datum));
+	indexNulls = palloc0((tupDesc->natts-2) * sizeof(bool));
+	memcpy(indexDatum, datum, (tupDesc->natts-2) * sizeof(Datum));
+	memcpy(indexNulls, nulls, (tupDesc->natts-2) * sizeof(bool));
+	result = 
+		index_insert(lovIndex, indexDatum, indexNulls, 
+					 &(tuple->t_self), lovHeap, true);
+
+	pfree(indexDatum);
+	pfree(indexNulls);
+	Assert(result);
+
+	heap_freetuple(tuple);
+}
+
+
+/*
+ * _bitmap_close_lov_heapandindex() -- close the heap and the index.
+ */
+void
+_bitmap_close_lov_heapandindex
+	(Relation lovHeap, Relation lovIndex, LOCKMODE lockMode)
+{
+	heap_close(lovHeap, lockMode);
+	index_close(lovIndex);
+}
+
+/*
+ * _bitmap_findvalue() -- find a given value in a given heap with
+ *  a given index.
+ * 
+ * If this value exists, this function returns true. Otherwise,
+ * returns false.
+ *
+ * If this value exists in the heap, this function also returns
+ * the block number and the offset number that are stored in the same
+ * row with this value. This block number and the offset number
+ * are for the LOV item that points the bitmap vector for this value.
+ */
+bool
+_bitmap_findvalue(Relation lovHeap, Relation lovIndex,
+				  Datum* datum, bool* isnull,
+				  ScanKey scanKey, IndexScanDesc scanDesc,
+				  BlockNumber *lovBlock, bool *blockNull,
+				  OffsetNumber *lovOffset, bool *offsetNull)
+{
+	TupleDesc		tupDesc;
+	HeapTuple		tuple;
+	bool			found = false;
+	int				attno;
+
+	tupDesc = RelationGetDescr(lovIndex);
+
+	for (attno = 0; attno<tupDesc->natts; attno++) {
+		ScanKey theScanKey =
+			(ScanKey)(((char*)scanKey) + attno * sizeof(ScanKeyData));
+		if (isnull[attno])
+		{
+			theScanKey->sk_flags = SK_ISNULL;
+			theScanKey->sk_argument = datum[attno];
+		}
+		else
+		{
+			theScanKey->sk_flags = 0;
+			theScanKey->sk_argument = datum[attno];
+		}
+	}
+
+	index_rescan(scanDesc, scanKey);
+
+	tuple = index_getnext(scanDesc, ForwardScanDirection);
+
+	if (tuple != NULL)
+	{
+		TupleDesc heapTupDesc;
+
+		found = true;
+
+		heapTupDesc = RelationGetDescr(lovHeap);
+
+		*lovBlock =
+			DatumGetInt32(heap_getattr(tuple, tupDesc->natts+1,
+										heapTupDesc, blockNull));
+		*lovOffset =
+			DatumGetInt16(heap_getattr(tuple, tupDesc->natts+2,
+										heapTupDesc, offsetNull));
+	}
+
+	return found;
+}
+
+/*
+ * _bitmap_insert_lov_block_number() -- insert a new lov block number
+ * 	into a given array.
+ *
+ * If the given array does not have enough space for this new block number,
+ * we increase the array size by BM_NUM_LOV_BLOCKS.
+ *
+ * This function assumes that the given array is sorted by the block
+ * numbers.
+ */
+void
+_bitmap_insert_lov_block_number(BlockNumber lovBlock,
+								BlockNumber** lovBlocks,
+								uint16*		numLovBlocks,
+								uint16*		maxNumLovBlocks)
+{
+	/* If this is not a real new block number, we do nothing. */
+	if ((*numLovBlocks > 0) && (lovBlock == ((*lovBlocks)[*numLovBlocks-1])))
+		return;
+
+	/*
+	 * If there is no enough space, we need to allocate a bigger
+	 * array to store all these block numbers.
+	 */
+	if (*numLovBlocks >= *maxNumLovBlocks)
+	{
+		BlockNumber* newLovBlock = (BlockNumber*)
+			palloc0(((*maxNumLovBlocks)+BM_NUM_LOV_BLOCKS)*
+					sizeof(BlockNumber));
+		memcpy(newLovBlock, *lovBlocks,
+			   (*maxNumLovBlocks)*sizeof(BlockNumber));
+		pfree(*lovBlocks);
+		*lovBlocks = newLovBlock;
+		*maxNumLovBlocks += BM_NUM_LOV_BLOCKS;
+	}
+
+	(*lovBlocks)[*numLovBlocks] = lovBlock;
+	(*numLovBlocks)++;
+}
+
+/*
+ * _bitmap_find_lov_index() -- find the index position for a given lov
+ *	block number in a given array.
+ *
+ * This function assumes that the given array is sorted by the block numbers.
+ */
+uint16
+_bitmap_find_lov_index(BlockNumber lovBlock, BlockNumber* lovBlocks,
+						uint16 numLovBlocks)
+{
+	int16	start, end, mid;
+
+	/* Since the given array is sorted, we use binary search here. */
+	start = 0;
+	end = numLovBlocks-1;
+	mid = start + (end-start)/2;
+
+	while (start < end)
+	{
+		if (lovBlocks[mid] > lovBlock)
+			end = mid - 1;
+		else if (lovBlocks[mid] < lovBlock)
+			start = mid + 1;
+		else
+			break;
+		mid = start + (end-start)/2;
+	}
+
+	Assert((mid >= start) && (mid <= end) && (lovBlocks[mid] == lovBlock));
+	return mid;
+}
